--This script will run on all levels when mod is active.
--Modding documentation: http://teardowngame.com/modding
--API reference: http://teardowngame.com/modding/api.html
DebugPrint("Mod file Loaded")
function init()
    DebugPrint("Mod Init called")
    --Register tool and enable it
	RegisterTool("eden_spark", "eDEN Spark", "MOD/vox/Eden_Spark.vox")
	SetBool("game.tool.eden_spark.enabled", true)
    ready = true
    readyCOUNT = 0
    delay_count = 0
end
function rndVec(t)
	return Vec(math.random(-t, t), math.random(-t, t), math.random(-t, t))
end
function tick(dt)
    if GetString("game.player.tool") == "eden_spark" then
        local offset = Transform(Vec(0.5, 0, 0))
		SetToolTransform(Transform(offset))
    end
        local t = GetCameraTransform()
        local fwd = TransformToParentVec(t, Vec(0, 0, -1))
    if ready == false then
        readyCOUNT = readyCOUNT + 1
        SetFloat("game.tool.eden_spark.ammo", 11 - readyCOUNT / 60)
        if readyCOUNT >= 600 then
            ready = true
            readyCOUNT = 0
        end
    end
    if ready == true then
        SetFloat("game.tool.eden_spark.ammo", 0)
    end
    if GetString("game.player.tool") == "eden_spark" and InputDown("grab") and ready == true then
        local t = GetCameraTransform()
	    local fwd = TransformToParentVec(t, Vec(0, 0, -1))
		local maxDist = 1000
		local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, maxDist)
		if not hit then
			dist = maxDist
		end
		
		--Start and end points
		local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
		local e = VecAdd(t.pos, VecScale(fwd, dist))
        if hit then
            SpawnFire(e)
            SpawnParticle("fire", e, 0.5, 0.5, 0.5)
            SpawnParticle("smoke", e, 0.5, 1.0, 1.0)
            ParticleReset()
            ParticleType("smoke")
            ParticleColor(0.1, 0.1, 0.9)
            --Spawn particle at world origo with upwards velocity and a lifetime of ten seconds
            local i = 0
            repeat
                i = i + 1
                SpawnParticle(Vec(e[1], e[2] + i, e[3]), Vec(0, 1, 0), 0.2)
            until i == 500
            readyCOUNT = readyCOUNT + 1
            if delay_count >= 5 then
                delay_count = 0
                Explosion(e, 2)
            end
            delay_count = delay_count + 1
            if readyCOUNT >= 1800 then
                ready = false
                readyCOUNT = 0
            end
        end
    end
    if GetString("game.player.tool") == "eden_spark" and InputDown("usetool") and ready == true then
        local t = GetCameraTransform()
	    local fwd = TransformToParentVec(t, Vec(0, 0, -1))
		local maxDist = 1000
		local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, maxDist)
		if not hit then
			dist = maxDist
		end
		
		--Start and end points
		local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
		local e = VecAdd(t.pos, VecScale(fwd, dist))
        if hit then
            local v = VecAdd(Vec(-6, 6, 0), rndVec(math.random(6*0.5, 6*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		    local v1 = VecAdd(Vec(6, 6, 0), rndVec(math.random(6*0.5, 6*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		    local v2 = VecAdd(Vec(-4, 4, 0), rndVec(math.random(4*0.5, 4*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		    local v3 = VecAdd(Vec(4, 4, 0), rndVec(math.random(4*0.5, 4*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		    local v4 = VecAdd(Vec(-2, 2, 0), rndVec(math.random(2*0.5, 2*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		    local v5 = VecAdd(Vec(2, 2, 0), rndVec(math.random(2*0.5, 2*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))

            SpawnFire(e)
            SpawnParticle("fire", e, 0.5, 0.5, 0.5)
            SpawnParticle("smoke", e, 0.5, 1.0, 1.0)
            ParticleReset()
            ParticleType("smoke")
            ParticleColor(0.1, 0.1, 0.9)
            ParticleReset()
		    ParticleStretch(5)
		    ParticleAlpha(1, 0)
		    ParticleEmissive(math.random(2,5), 1.5, "easeout")
		    ParticleGravity(-10)
		    ParticleRadius(0.3, 0, "easein")
		    ParticleColor(0, 0.4, 1)
		    ParticleTile(0)
		    for i=1, 5 do
		    SpawnParticle(e, v, life)
		    SpawnParticle(e, v1, life)
		    SpawnParticle(e, v2, life)
		    local life = math.random(0.75, 0.85)
		    life = life*life * 0.75
		    SpawnParticle(e, v3, life)
		    SpawnParticle(e, v4, life)
		    SpawnParticle(e, v5, life)
            --Spawn particle at world origo with upwards velocity and a lifetime of ten seconds
            local i = 0
            repeat
                i = i + 0.5
                SpawnParticle(Vec(e[1], e[2] + i, e[3]), Vec(0, 1, 0), 0.2)
            until i == 500
            if delay_count >= 5 then
                delay_count = 0
                MakeHole(e, 25, 12.5, 6.25, true)
                Paint(e, 35, "explosion")
                local snd = LoadSound("snd/active.ogg")
                PlaySound(snd)
                local u = 0
                repeat
                    u = u + 1
                    SpawnParticle(e, rndVec(50), 0.1)
                until u == 100
            end
            delay_count = delay_count + 1
            readyCOUNT = readyCOUNT + 2
            if readyCOUNT >= 1800 then
                ready = false
                readyCOUNT = 0
            end
        end
    end
end
end


function update(dt)
end


function draw(dt)
    SetFloat("game.tool.lasergun.ammo", readyCOUNT - readyCOUNT - readyCOUNT / 60)
end


